package com.example.myapplication;

import android.widget.LinearLayout;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.util.zip.InflaterOutputStream;

public class Client extends Thread {

    private boolean isMessage = false;
    private String message = "";
    private CreateMessage createMessage;
    private ReadServer readServer;

    public Client(CreateMessage m) {
        this.createMessage = m;
    }

    public void SendMessage(String msg) {
        message = msg;
        isMessage = true;
    }

    @Override
    public void run() {
        try {
            Socket socket = new Socket("192.168.0.2", 3243);

            readServer = new ReadServer(socket, createMessage);
            readServer.start();

            while (!isInterrupted()) {
                if (!isMessage) {
                    continue;
                }

                isMessage = false;

                OutputStream os = socket.getOutputStream();

                os.write(message.getBytes());
                os.flush();

            }

        } catch (IOException e) {
            e.printStackTrace();
        }

        readServer.interrupt();

        try {
            readServer.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }
}

class ReadServer extends Thread {
    private Socket socket;
    private CreateMessage createMessage;

    public ReadServer(Socket socket, CreateMessage createMessage) {
        this.socket = socket;
        this.createMessage = createMessage;
    }

    @Override
    public void run() {

        byte[] data = new byte[2048];

        while (!isInterrupted()) {

            try {
                InputStream io = socket.getInputStream();

                io.read(data);

                createMessage.Callback(new String(data));

            } catch (IOException e) {
                e.printStackTrace();
            }

        }
    }
}